> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Swap data model source elements (Beta)

POST https://api.sigmacomputing.com/v2/dataModels/{dataModelId}/swapSourceElements
Content-Type: application/json

Swap individual source elements in a data model. You can swap from one table, dataset (deprecated), data model element, or custom SQL element to another.

**Beta**: This documentation describes a public beta feature and is subject to the [Beta features](/docs/sigma-product-releases#beta-features) disclaimer.

### Usage notes

* Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.
* Retrieve data model sources by calling the [/v2/dataModels/\{dataModelId}/sources](https://help.sigmacomputing.com/reference/list-data-model-sources) endpoint.
* Retrieve the **datasetId** by calling the [/v2/datasets](https://help.sigmacomputing.com/reference/list-datasets) endpoint. (Deprecated)
* Retrieve the **tableId** by calling the [/v2/connection](https://help.sigmacomputing.com/reference/lookup-connection) endpoint.
* Retrieve the **connectionId** for a new custom SQL element by calling the [/v2/connections](https://help.sigmacomputing.com/reference/list-connections) endpoint.
* Use the `sourceMapping` options in the request body to swap specific source elements. For each source element, provide the current source in the **from** object and the source to use instead in the **to** object.
* If your source is a data model with one or more tagged versions, you can also provide a `versionTagId` to swap to or from a tagged version of the data model. The data model version must already be tagged.
* When swapping **from** a custom SQL source, set `customSqlSourceId` to the value returned by the [/v2/dataModels/\{dataModelId}/sources](https://help.sigmacomputing.com/reference/list-data-model-sources) endpoint. When swapping **to** a custom SQL element, supply the `connectionId` of the connection to run against and the SQL query in the `definition` field.
* If your source is a data model or a dataset (deprecated), you can use the `metricMapping` option to map metrics that rely on column names from the old source to the new one so that they continue to work.
* If the source that you swap from uses column names, links, or relationships different from the source that you are swapping to, use the `columnMapping` option to map each column in the original source to a corresponding column in the new source.
* When `columnMapping` is omitted, columns are automatically matched by display name, ignoring differences in case and punctuation. For example, a custom SQL output column named `DOCK_COUNT` automatically maps to a column with display name `Dock Count` in the target source. Provide `columnMapping` explicitly to override the automatic match for a column.
* `unswappedSources` lists the `from` object for each requested source element that could not be swapped.

### Usage scenarios

* **Data model development**: Use a test data source during development, then swap to a production source when ready.
* **Dataset migration**: Update references to legacy dataset sources with data model sources by mapping dataset IDs to their new data model equivalents.

Reference: https://help.sigmacomputing.com/reference/swap-data-model-source-elements

## Authentication

- OAuth2 — send the obtained token as `Authorization: Bearer <token>`

## Servers

- `https://api.sigmacomputing.com` (Server for GCP (US) hosted organizations, default)
- `https://api.sa.gcp.sigmacomputing.com` (Server for GCP (KSA) hosted organizations)
- `https://aws-api.sigmacomputing.com` (Server for AWS US (West) hosted organizations)
- `https://api.us-a.aws.sigmacomputing.com` (Server for AWS US (East) hosted organizations)
- `https://api.ca.aws.sigmacomputing.com` (Server for AWS Canada hosted organizations)
- `https://api.eu.aws.sigmacomputing.com` (Server for AWS Europe (Frankfurt) hosted organizations)
- `https://api.ch.aws.sigmacomputing.com` (Server for AWS Europe (Zurich) hosted organizations)
- `https://api.au.aws.sigmacomputing.com` (Server for AWS Australia and APAC hosted organizations)
- `https://api.uk.aws.sigmacomputing.com` (Server for AWS UK hosted organizations)
- `https://api.in.aws.sigmacomputing.com` (Server for AWS Asia Pacific (Mumbai) hosted organizations)
- `https://api.us.azure.sigmacomputing.com` (Server for Azure US hosted organizations)
- `https://api.eu.azure.sigmacomputing.com` (Server for Azure Europe hosted organizations)
- `https://api.ca.azure.sigmacomputing.com` (Server for Azure Canada hosted organizations)
- `https://api.uk.azure.sigmacomputing.com` (Server for Azure United Kingdom hosted organizations)
- `https://api.au.azure.sigmacomputing.com` (Server for Azure Australia hosted organizations)

## Request

### Path parameters

- `dataModelId` (string, required) — Unique identifier of the data model.

### Body (application/json)

This endpoint expects an object.

- `sourceMapping` (list of V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItems, required)

## Response

### 200

The response body.

- `unswappedSources` (list of V2DataModelsDataModelIdSwapSourceElementsPostResponsesContentApplicationJsonSchemaUnswappedSourcesItems, required) — Sources from the request that were not swapped.

## Types

### V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItems

- `from` (V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsFrom, required) — Source to swap from.
- `to` (V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsTo, required) — Source to swap to.
- `metricMapping` (list of V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsMetricMappingItems, optional)
- `columnMapping` (list of V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItems, optional)

### V2DataModelsDataModelIdSwapSourceElementsPostResponsesContentApplicationJsonSchemaUnswappedSourcesItems

- Table source: Table source
- Dataset source (deprecated): Dataset source (deprecated)
- Data model source: V2DataModelsDataModelIdSwapSourceElementsPostResponsesContentApplicationJsonSchemaUnswappedSourcesItems2
- Custom SQL element: Custom SQL element

### V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsFrom

Source to swap from.

- Table source: Table source
- Dataset source (deprecated): Dataset source (deprecated)
- Data model source: V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsFrom2
- Custom SQL element: Custom SQL element

### V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsTo

Source to swap to.

- Table source: Table source
- Dataset source (deprecated): Dataset source (deprecated)
- Data model source: V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsTo2
- Custom SQL element: Custom SQL element

### V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsMetricMappingItems

- `fromMetricId` (string, required) — Identifier of the metric in the data source
- `toMetricId` (string, required) — Identifier of the metric in the data source

### V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItems

- `fromColumn` (V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsFromColumn, required)
- `toColumn` (V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsToColumn, required)

### Table source

- `type` (enum, required)
  - Allowed values: `table`
- `tableId` (string, required)

### Dataset source (deprecated)

- `type` (enum, required)
  - Allowed values: `dataset`
- `datasetId` (string, required)

### V2DataModelsDataModelIdSwapSourceElementsPostResponsesContentApplicationJsonSchemaUnswappedSourcesItems2

- `type` (enum, required)
  - Allowed values: `data-model`
- `dataModelId` (string, required)
- `elementId` (string, required) — ID of the element in the data model
- `versionTagId` (string, optional)

### Custom SQL element

- `type` (enum, required)
  - Allowed values: `custom-sql`
- `customSqlSourceId` (string, required) — ID of the custom SQL source.

### Table source

- `type` (enum, required)
  - Allowed values: `table`
- `tableId` (string, required)

### Dataset source (deprecated)

- `type` (enum, required)
  - Allowed values: `dataset`
- `datasetId` (string, required)

### V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsFrom2

- `type` (enum, required)
  - Allowed values: `data-model`
- `dataModelId` (string, required)
- `elementId` (string, required) — ID of the element in the data model
- `versionTagId` (string, optional)

### Custom SQL element

- `type` (enum, required)
  - Allowed values: `custom-sql`
- `customSqlSourceId` (string, required) — ID of the custom SQL source.

### Table source

- `type` (enum, required)
  - Allowed values: `table`
- `tableId` (string, required)

### Dataset source (deprecated)

- `type` (enum, required)
  - Allowed values: `dataset`
- `datasetId` (string, required)

### V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsTo2

- `type` (enum, required)
  - Allowed values: `data-model`
- `dataModelId` (string, required)
- `elementId` (string, required) — ID of the element in the data model
- `versionTagId` (string, optional)

### Custom SQL element

- `type` (enum, required)
  - Allowed values: `custom-sql`
- `connectionId` (string, required) — ID of the connection that the new custom SQL element will run against.
- `definition` (string, required) — SQL query that defines the new custom SQL element.

### V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsFromColumn

- list of string
- list of string
- list of string

### V2DataModelsDataModelIdSwapSourceElementsPostRequestBodyContentApplicationJsonSchemaSourceMappingItemsColumnMappingItemsToColumn

- list of string
- list of string
- list of string

## Examples

**Request**

```json
{
  "sourceMapping": [
    {
      "from": {
        "tableId": "string",
        "type": "table"
      },
      "to": {
        "tableId": "string",
        "type": "table"
      }
    }
  ]
}
```

**Response**

```json
{
  "unswappedSources": [
    {
      "tableId": "string",
      "type": "table"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSourceElements"

payload = { "sourceMapping": [
        {
            "from": {
                "tableId": "string",
                "type": "table"
            },
            "to": {
                "tableId": "string",
                "type": "table"
            }
        }
    ] }
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSourceElements';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"sourceMapping":[{"from":{"tableId":"string","type":"table"},"to":{"tableId":"string","type":"table"}}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSourceElements"

	payload := strings.NewReader("{\n  \"sourceMapping\": [\n    {\n      \"from\": {\n        \"tableId\": \"string\",\n        \"type\": \"table\"\n      },\n      \"to\": {\n        \"tableId\": \"string\",\n        \"type\": \"table\"\n      }\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSourceElements")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"sourceMapping\": [\n    {\n      \"from\": {\n        \"tableId\": \"string\",\n        \"type\": \"table\"\n      },\n      \"to\": {\n        \"tableId\": \"string\",\n        \"type\": \"table\"\n      }\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSourceElements")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"sourceMapping\": [\n    {\n      \"from\": {\n        \"tableId\": \"string\",\n        \"type\": \"table\"\n      },\n      \"to\": {\n        \"tableId\": \"string\",\n        \"type\": \"table\"\n      }\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSourceElements', [
  'body' => '{
  "sourceMapping": [
    {
      "from": {
        "tableId": "string",
        "type": "table"
      },
      "to": {
        "tableId": "string",
        "type": "table"
      }
    }
  ]
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSourceElements");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"sourceMapping\": [\n    {\n      \"from\": {\n        \"tableId\": \"string\",\n        \"type\": \"table\"\n      },\n      \"to\": {\n        \"tableId\": \"string\",\n        \"type\": \"table\"\n      }\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = ["sourceMapping": [
    [
      "from": [
        "tableId": "string",
        "type": "table"
      ],
      "to": [
        "tableId": "string",
        "type": "table"
      ]
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSourceElements")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```